Hot News aus dem CAD.de-Newsletter:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Lisp
  read und Anführungszeichen

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   read und Anführungszeichen (581 mal gelesen)
joern bosse
Ehrenmitglied
Dipl.-Ing. Vermessung


Sehen Sie sich das Profil von joern bosse an!   Senden Sie eine Private Message an joern bosse  Schreiben Sie einen Gästebucheintrag für joern bosse

Beiträge: 1615
Registriert: 11.10.2004

Window 8.1
ACAD 2005-2018
CIVIL 2010 - 2018
BricsCAD V13-V18
Intel(R) Core(TM)i7-4700HQ CPU @ 2.40GHz 2.40 GHz
16.0GB RAM
NVIDIA GeForce GTX 850M

erstellt am: 03. Jun. 2009 14:34    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo,
ich möchte mit mit der Funktion READ aus einem String eine auswertbare Funktion erzeugen:
Code:

(defun c:test  (/ textwert filter)
  (setq textwert "test"
        filter  "*es*")
  (eval (read (strcat "(wcmatch \"" textwert "\"\"" filter "\")"))))

Das funzt auch soweit, sobald der Textwert aber ein Anführungszeichen enthält kommt die READ-Funktion damit nicht mehr klar.

Code:

(defun c:test1  (/ textwert filter)
  (setq textwert "\"test"
        filter  "*es*")
  (eval (read (strcat "(wcmatch \"" textwert "\"\"" filter "\")"))))

Gibt es da einen Trick???

------------------
viele Grüße

Jörn
http://www.bosse-engineering.com

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Andreas Kraus
Mitglied
Elektrotechniker


Sehen Sie sich das Profil von Andreas Kraus an!   Senden Sie eine Private Message an Andreas Kraus  Schreiben Sie einen Gästebucheintrag für Andreas Kraus

Beiträge: 1045
Registriert: 11.01.2006

WIN 10
ACAD 2017

erstellt am: 03. Jun. 2009 14:41    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für joern bosse 10 Unities + Antwort hilfreich

Ja, du mußt den Backslash auch in den String fummeln.
Also:

(defun c:test1  (/ textwert filter)
  (setq textwert "\\\"test"
        filter  "*es*")
  (eval (read (strcat "(wcmatch \"" textwert "\"\"" filter "\")"))))

------------------
Gruß
Andreas

http://kraus-cad.de

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

joern bosse
Ehrenmitglied
Dipl.-Ing. Vermessung


Sehen Sie sich das Profil von joern bosse an!   Senden Sie eine Private Message an joern bosse  Schreiben Sie einen Gästebucheintrag für joern bosse

Beiträge: 1615
Registriert: 11.10.2004

Window 8.1
ACAD 2005-2018
CIVIL 2010 - 2018
BricsCAD V13-V18
Intel(R) Core(TM)i7-4700HQ CPU @ 2.40GHz 2.40 GHz
16.0GB RAM
NVIDIA GeForce GTX 850M

erstellt am: 03. Jun. 2009 15:20    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Andy,
danke für den Wink mit dem Zaunpfahl, so geht es natürlich.
Anbei noch ein Funktion zum ergänzen der Backslashes wenn ein Anführungszeichen im String gefunden wird.
Code:

(defun test:replace (textwert / )
  (vl-list->string
  (apply 'append
  (mapcar '(lambda(A)
            (if (= A 34)
              (list 92 34)
              (list A)))
    (vl-string->list textwert)))))


------------------
viele Grüße

Jörn
http://www.bosse-engineering.com

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Andreas Kraus
Mitglied
Elektrotechniker


Sehen Sie sich das Profil von Andreas Kraus an!   Senden Sie eine Private Message an Andreas Kraus  Schreiben Sie einen Gästebucheintrag für Andreas Kraus

Beiträge: 1045
Registriert: 11.01.2006

WIN 10
ACAD 2017

erstellt am: 03. Jun. 2009 23:15    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für joern bosse 10 Unities + Antwort hilfreich

geht das nicht auch mit:

(vl-string-subst "\\\"" "\"" textwert)

oder hab ich da was übersehn ?

------------------
Gruß
Andreas

http://kraus-cad.de

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

joern bosse
Ehrenmitglied
Dipl.-Ing. Vermessung


Sehen Sie sich das Profil von joern bosse an!   Senden Sie eine Private Message an joern bosse  Schreiben Sie einen Gästebucheintrag für joern bosse

Beiträge: 1615
Registriert: 11.10.2004

Window 8.1
ACAD 2005-2018
CIVIL 2010 - 2018
BricsCAD V13-V18
Intel(R) Core(TM)i7-4700HQ CPU @ 2.40GHz 2.40 GHz
16.0GB RAM
NVIDIA GeForce GTX 850M

erstellt am: 04. Jun. 2009 07:32    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Andreas,
vom Prinzip schon, aber nicht wenn mehrere Anführungstriche im String enthalten sind.
Bei

(while (vl-string-search "\"" textwert)
(setq textwert (vl-string-subst "\\\"" "\"" textwert)))

würden sich die Anführungstriche stetig vermehren bis der Rechner nicht mehr kann 

------------------
viele Grüße

Jörn
http://www.bosse-engineering.com

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP



Versuchsingenieur (m/w) Versuch | Erprobung

Ihr Herz schlägt für Fahrzeuge?
Schaffen Sie gemeinsam mit uns innovative Ideen!

Mit unseren Standorten in Deutschland, China und Mexico sind wir der innovative Partner in der Fahrzeugentwicklung. In einem hoch motivierten Team arbeiten Sie an anspruchsvollen Aufgaben mit viel Freiraum für Ihre Ideen. Wir bieten Ihnen ein verantwortungsvolles Arbeitsumfeld und fördern Ihre fachliche Entwicklung und persönlichen Stärken....

Anzeige ansehenFahrzeugtechnik
Andreas Kraus
Mitglied
Elektrotechniker


Sehen Sie sich das Profil von Andreas Kraus an!   Senden Sie eine Private Message an Andreas Kraus  Schreiben Sie einen Gästebucheintrag für Andreas Kraus

Beiträge: 1045
Registriert: 11.01.2006

WIN 10
ACAD 2017

erstellt am: 04. Jun. 2009 08:39    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für joern bosse 10 Unities + Antwort hilfreich

Ah ja

Aber so vielleicht:

(vl-list->string
  (apply 'append
(subst '(92 34)
'(34)
(mapcar 'list
(vl-string->list textwert)
)
)
  )
)

------------------
Gruß
Andreas

http://kraus-cad.de

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2018 CAD.de